<?php

function _blogUpdate() {
    global $objDatabase, $_ARRAYLANG, $_CORELANG, $objUpdate, $_CONFIG;

    /*
     * Check for missing setting "blog_comments_editor" in database. In the update-package for 1.2 this value somehow
     * got lost.
     */
    $query = '	SELECT 	name
				FROM	`' . DBPREFIX . 'module_blog_settings`
				WHERE	name="blog_comments_editor"
				LIMIT	1';

    $objResult = $objDatabase->Execute($query);

    if ($objResult !== false) {
        if ($objResult->RecordCount() == 0) {
            $query = "INSERT INTO `" . DBPREFIX . "module_blog_settings` ( `name` , `value` ) VALUES ('blog_comments_editor', 'wysiwyg')";

            if ($objDatabase->Execute($query) === false) {
                return _databaseError($query, $objDatabase->ErrorMsg());
            }
        }
    } else {
        return _databaseError($query, $objDatabase->ErrorMsg());
    }

    try {
        \Cx\Lib\UpdateUtil::table(
            DBPREFIX . 'module_blog_categories', array(
                'category_id' => array('type' => 'INT(4)', 'unsigned' => true, 'notnull' => true, 'default' => '0', 'primary' => true),
                'lang_id' => array('type' => 'INT(2)', 'unsigned' => true, 'notnull' => true, 'default' => '0', 'primary' => true),
                'is_active' => array('type' => 'ENUM(\'0\',\'1\')', 'notnull' => true, 'default' => '1'),
                'name' => array('type' => 'VARCHAR(100)', 'notnull' => true, 'default' => '')
            )
        );

        \Cx\Lib\UpdateUtil::table(
            DBPREFIX . 'module_blog_comments', array(
                'comment_id' => array('type' => 'INT(7)', 'unsigned' => true, 'notnull' => true, 'auto_increment' => true, 'primary' => true),
                'message_id' => array('type' => 'INT(6)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'lang_id' => array('type' => 'INT(2)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'is_active' => array('type' => 'ENUM(\'0\',\'1\')', 'notnull' => true, 'default' => '1'),
                'time_created' => array('type' => 'INT(14)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'ip_address' => array('type' => 'VARCHAR(15)', 'notnull' => true, 'default' => '0.0.0.0'),
                'user_id' => array('type' => 'INT(5)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'user_name' => array('type' => 'VARCHAR(50)', 'notnull' => false),
                'user_mail' => array('type' => 'VARCHAR(250)', 'notnull' => false),
                'user_www' => array('type' => 'VARCHAR(255)', 'notnull' => false),
                'subject' => array('type' => 'VARCHAR(250)', 'notnull' => true, 'default' => ''),
                'comment' => array('type' => 'TEXT')
            ), array(
                'message_id' => array('fields' => array('message_id'))
            )
        );

        \Cx\Lib\UpdateUtil::table(
            DBPREFIX . 'module_blog_message_to_category', array(
                'message_id' => array('type' => 'INT(6)', 'unsigned' => true, 'notnull' => true, 'default' => '0', 'primary' => true),
                'category_id' => array('type' => 'INT(4)', 'unsigned' => true, 'notnull' => true, 'default' => '0', 'primary' => true),
                'lang_id' => array('type' => 'INT(2)', 'unsigned' => true, 'notnull' => true, 'default' => '0', 'primary' => true)
            ), array(
                'category_id' => array('fields' => array('category_id'))
            )
        );

        \Cx\Lib\UpdateUtil::table(
            DBPREFIX . 'module_blog_messages', array(
                'message_id' => array('type' => 'INT(6)', 'unsigned' => true, 'notnull' => true, 'auto_increment' => true, 'primary' => true),
                'user_id' => array('type' => 'INT(5)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'time_created' => array('type' => 'INT(14)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'time_edited' => array('type' => 'INT(14)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'hits' => array('type' => 'INT(7)', 'unsigned' => true, 'notnull' => true, 'default' => '0')
            )
        );

        \Cx\Lib\UpdateUtil::table(
            DBPREFIX . 'module_blog_networks_lang', array(
                'network_id' => array('type' => 'INT(8)', 'unsigned' => true, 'notnull' => true, 'default' => '0', 'primary' => true),
                'lang_id' => array('type' => 'INT(2)', 'unsigned' => true, 'notnull' => true, 'default' => '0', 'primary' => true)
            )
        );

        \Cx\Lib\UpdateUtil::table(
            DBPREFIX . 'module_blog_votes', array(
                'vote_id' => array('type' => 'INT(8)', 'unsigned' => true, 'notnull' => true, 'auto_increment' => true, 'primary' => true),
                'message_id' => array('type' => 'INT(6)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'time_voted' => array('type' => 'INT(14)', 'unsigned' => true, 'notnull' => true, 'default' => '0'),
                'ip_address' => array('type' => 'VARCHAR(15)', 'notnull' => true, 'default' => '0.0.0.0'),
                'vote' => array('type' => 'ENUM(\'1\',\'2\',\'3\',\'4\',\'5\',\'6\',\'7\',\'8\',\'9\',\'10\')', 'notnull' => true, 'default' => '1')
            ), array(
                'message_id' => array('fields' => array('message_id'))
            )
        );
    } catch (\Cx\Lib\UpdateException $e) {
        // we COULD do something else here..
        return \Cx\Lib\UpdateUtil::DefaultActionHandler($e);
    }

    try { //update to 2.2.3 in this block
        if ($objUpdate->_isNewerVersion($_CONFIG['coreCmsVersion'], '2.2.3')) {
            //we've hidden the wysiwyg - let's default to textarea
            \Cx\Lib\UpdateUtil::sql('UPDATE ' . DBPREFIX . 'module_blog_settings SET value="textarea" WHERE name="blog_comments_editor"');

            //comments: convert escaped db entries to their unescaped equivalents
            $rs = \Cx\Lib\UpdateUtil::sql('SELECT comment_id, comment FROM  ' . DBPREFIX . 'module_blog_comments');
            while (!$rs->EOF) {
                $content = $rs->fields['comment'];
                $id = $rs->fields['comment_id'];
                $content = contrexx_raw2db(html_entity_decode($content, ENT_QUOTES, CONTREXX_CHARSET));
                \Cx\Lib\UpdateUtil::sql('UPDATE ' . DBPREFIX . 'module_blog_comments SET comment="' . $content . '" WHERE comment_id=' . $id);
                $rs->MoveNext();
            }
        }
    } catch (\Cx\Lib\UpdateException $e) {
        // we COULD do something else here..
        return \Cx\Lib\UpdateUtil::DefaultActionHandler($e);
    }


    try {
        // migrate content page to version 3.0.1
        $search = array(
        '/(.*)/ms',
        );
        $callback = function($matches) {
            $content = $matches[1];
            if (empty($content)) {
                return $content;
            }

            // replace placeholder {TXT_COMMENT_ADD_SPAM} with {TXT_COMMENT_CAPTCHA}
            $content = str_replace('{TXT_COMMENT_ADD_SPAM}', '{TXT_COMMENT_CAPTCHA}', $content);

            // replace <img src="[[BLOG_DETAILS_COMMENT_ADD_SPAM_URL]]" alt="[[BLOG_DETAILS_COMMENT_ADD_SPAM_ALT]]" title="[[BLOG_DETAILS_COMMENT_ADD_SPAM_ALT]]" /> with {COMMENT_CAPTCHA_CODE}
            $content = preg_replace('/<img[^>]+\{BLOG_DETAILS_COMMENT_ADD_SPAM_URL\}[^>]+>/ms', '{COMMENT_CAPTCHA_CODE}', $content);

            // remove <input type="text" name="frmAddComment_Captcha" />
            $content = preg_replace('/<input[^>]+name\s*=\s*[\'"]frmAddComment_Captcha[^>]+>/ms', '', $content);

            // remove <input type="hidden" name="frmAddComment_Offset" value="[[BLOG_DETAILS_COMMENT_ADD_SPAM_OFFSET]]" />
            $content = preg_replace('/<(div|p)[^>]*>\s*<input[^>]+name\s*=\s*[\'"]frmAddComment_Offset[^>]+>\s*<\/(div|p)>/ms', '', $content);

            // add missing comment_captcha template block
            if (!preg_match('/<!--\s+BEGIN\s+comment_captcha\s+-->.*<!--\s+END\s+comment_captcha\s+-->/ms', $content)) {
                $content = preg_replace('/(.*)(<(div|p)[^{]*?>.*?\{TXT_COMMENT_CAPTCHA\}.*?\{COMMENT_CAPTCHA_CODE\}.*?<\/\3>)/ms', '$1<!-- BEGIN comment_captcha -->$2<!-- END comment_captcha -->', $content, -1, $count);
                if (!$count) {
                    $content = preg_replace('/(.*)(<(div|p)[^{]*?>.*?\{COMMENT_CAPTCHA_CODE\}.*?<\/\3>)/ms', '$1<!-- BEGIN comment_captcha -->$2<!-- END comment_captcha -->', $content, -1, $count);
                }
            }

            return $content;
        };

        \Cx\Lib\UpdateUtil::migrateContentPageUsingRegexCallback(array('module' => 'blog', 'cmd' => 'details'), $search, $callback, array('content'), '3.0.1');
    } catch (\Cx\Lib\UpdateException $e) {
        return \Cx\Lib\UpdateUtil::DefaultActionHandler($e);
    }


    /**
     * Everything went fine. Return without any errors.
     */
    return true;
}
function _blogInstall() {
	global $_DBCONFIG;
	try {
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_categories` (
  `category_id` int(4) unsigned NOT NULL default \'0\',
  `lang_id` int(2) unsigned NOT NULL default \'0\',
  `is_active` enum(\'0\',\'1\') NOT NULL default \'1\',
  `name` varchar(100) NOT NULL default \'\',
  PRIMARY KEY  (`category_id`,`lang_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_categories` (`category_id`, `lang_id`, `is_active`, `name`) VALUES (\'1\', \'1\', \'1\', \'Allgemein\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_categories` (`category_id`, `lang_id`, `is_active`, `name`) VALUES (\'1\', \'2\', \'1\', \'General\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_categories` (`category_id`, `lang_id`, `is_active`, `name`) VALUES (\'1\', \'3\', \'1\', \'General\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_categories` (`category_id`, `lang_id`, `is_active`, `name`) VALUES (\'1\', \'4\', \'1\', \'General\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_categories` (`category_id`, `lang_id`, `is_active`, `name`) VALUES (\'1\', \'5\', \'1\', \'General\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_categories` (`category_id`, `lang_id`, `is_active`, `name`) VALUES (\'1\', \'6\', \'1\', \'General\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_comments` (
  `comment_id` int(7) unsigned NOT NULL auto_increment,
  `message_id` int(6) unsigned NOT NULL default \'0\',
  `lang_id` int(2) unsigned NOT NULL default \'0\',
  `is_active` enum(\'0\',\'1\') NOT NULL default \'1\',
  `time_created` int(14) unsigned NOT NULL default \'0\',
  `ip_address` varchar(15) NOT NULL default \'0.0.0.0\',
  `user_id` int(5) unsigned NOT NULL default \'0\',
  `user_name` varchar(50) default NULL,
  `user_mail` varchar(250) default NULL,
  `user_www` varchar(255) default NULL,
  `subject` varchar(250) NOT NULL default \'\',
  `comment` text NOT NULL,
  PRIMARY KEY  (`comment_id`),
  KEY `message_id` (`message_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_messages` (
  `message_id` int(6) unsigned NOT NULL auto_increment,
  `user_id` int(5) unsigned NOT NULL default \'0\',
  `time_created` int(14) unsigned NOT NULL default \'0\',
  `time_edited` int(14) unsigned NOT NULL default \'0\',
  `hits` int(7) unsigned NOT NULL default \'0\',
  PRIMARY KEY  (`message_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages` (`message_id`, `user_id`, `time_created`, `time_edited`, `hits`) VALUES (\'5\', \'1\', \'1338990215\', \'1345209958\', \'13\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages` (`message_id`, `user_id`, `time_created`, `time_edited`, `hits`) VALUES (\'6\', \'1\', \'1339076909\', \'1345210026\', \'110\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_messages_lang` (
  `message_id` int(6) unsigned NOT NULL,
  `lang_id` int(2) unsigned NOT NULL,
  `is_active` enum(\'0\',\'1\') NOT NULL default \'1\',
  `subject` varchar(250) NOT NULL default \'\',
  `content` text NOT NULL,
  `tags` varchar(250) NOT NULL default \'\',
  `image` varchar(250) NOT NULL default \'\',
  PRIMARY KEY  (`message_id`,`lang_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages_lang` (`message_id`, `lang_id`, `is_active`, `subject`, `content`, `tags`, `image`) VALUES (\'5\', \'3\', \'1\', \'\', \'\', \'\', \'\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages_lang` (`message_id`, `lang_id`, `is_active`, `subject`, `content`, `tags`, `image`) VALUES (\'5\', \'2\', \'1\', \'Are you utilizing your company software layer?\', \'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat.\', \'blog\', \'images/blog/postimg2.jpg\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages_lang` (`message_id`, `lang_id`, `is_active`, `subject`, `content`, `tags`, `image`) VALUES (\'5\', \'1\', \'1\', \'\', \'\', \'\', \'\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages_lang` (`message_id`, `lang_id`, `is_active`, `subject`, `content`, `tags`, `image`) VALUES (\'6\', \'2\', \'1\', \'How to break the Financial Inertia?\', \'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat.\', \'blog\', \'images/blog/postimg1.jpg\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages_lang` (`message_id`, `lang_id`, `is_active`, `subject`, `content`, `tags`, `image`) VALUES (\'6\', \'3\', \'1\', \'\', \'\', \'\', \'\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_messages_lang` (`message_id`, `lang_id`, `is_active`, `subject`, `content`, `tags`, `image`) VALUES (\'6\', \'1\', \'1\', \'\', \'\', \'\', \'\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_message_to_category` (
  `message_id` int(6) unsigned NOT NULL default \'0\',
  `category_id` int(4) unsigned NOT NULL default \'0\',
  `lang_id` int(2) unsigned NOT NULL default \'0\',
  PRIMARY KEY  (`message_id`,`category_id`,`lang_id`),
  KEY `category_id` (`category_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_networks` (
  `network_id` int(8) unsigned NOT NULL auto_increment,
  `name` varchar(250) NOT NULL default \'\',
  `url` varchar(255) NOT NULL default \'\',
  `url_link` varchar(255) NOT NULL default \'\',
  `icon` varchar(255) NOT NULL default \'\',
  PRIMARY KEY  (`network_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'1\', \'Digg\', \'http://www.digg.com\', \'http://digg.com/submit?phase=2&url=[URL]&title=[SUBJECT]\', \'images/blog/networks/digg.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'2\', \'del.icio.ous\', \'http://del.icio.us\', \'http://del.icio.us/post?url=[URL]&title=[SUBJECT]\', \'images/blog/networks/delicious.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'3\', \'Mister Wong\', \'http://www.mister-wong.de\', \'http://www.mister-wong.de/index.php?action=addurl&bm_url=[URL]&bm_description=[SUBJECT]\', \'images/blog/networks/wong.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'4\', \'Google Bookmarks\', \'http://www.google.com/bookmarks/\', \'http://www.google.com/bookmarks/mark?op=edit&output=popup&bkmk=[URL]&title=[SUBJECT]\', \'images/blog/networks/google.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'5\', \'Furl\', \'http://www.furl.net\', \'http://furl.net/storeIt.jsp?t=[SUBJECT]&u=[URL]\', \'images/blog/networks/furl.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'6\', \'reddit\', \'http://www.reddit.com/\', \'http://reddit.com/submit?url=[URL]&title=[SUBJECT]\', \'images/blog/networks/reddit.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'7\', \'Yigg\', \'http://www.yigg.de\', \'http://yigg.de/neu?exturl=[URL]&exttitle=[SUBJECT]\', \'images/blog/networks/yigg.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'8\', \'BlinkList\', \'http://www.blinklist.com\', \'http://www.blinklist.com/index.php?Action=Blink/addblink.php&Description=&Url=[URL]&Title=[SUBJECT]\', \'images/blog/networks/blinklist.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'9\', \'Blogmarks\', \'http://www.blogmarks.net\', \'http://blogmarks.net/my/new.php?mini=1&simple=1&url=[URL]&title=[SUBJECT]\', \'images/blog/networks/blogmarks.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'12\', \'Folkd\', \'http://www.folkd.com\', \'http://www.folkd.com/submit/page/[URL]\', \'images/blog/networks/folkd.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'13\', \'Linkarena\', \'http://www.linkarena.com\', \'http://linkarena.com/bookmarks/addlink/?url=[URL]&title=[SUBJECT]&desc=&tags=\', \'images/blog/networks/linkarena.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'15\', \'Newsvine\', \'http://www.newsvine.com\', \'http://www.newsvine.com/_wine/save?u=[URL]&h=[SUBJECT]\', \'images/blog/networks/newsvine.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'16\', \'OneView\', \'http://oneview.com\', \'http://oneview.com/link/quickadd/?URL=[URL]&title=[SUBJECT]\', \'images/blog/networks/oneview.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'18\', \'Squidoo\', \'http://www.squidoo.com\', \'http://www.squidoo.com/lensmaster/bookmark?[URL]\', \'images/blog/networks/squidoo.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'19\', \'Stumble Upon\', \'http://www.stumbleupon.com\', \'http://www.stumbleupon.com/refer.php?url=[URL]&title=[SUBJECT]\', \'images/blog/networks/stumbleupon.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'20\', \'Technorati\', \'http://www.technorati.com\', \'http://www.technorati.com/faves?add=[URL]\', \'images/blog/networks/technorati.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'21\', \'Webnews\', \'http://www.webnews.de\', \'http://www.webnews.de/einstellen?url=[URL]&title=[SUBJECT]\', \'images/blog/networks/webnews.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'22\', \'Yahoo My Web\', \'http://myweb2.search.yahoo.com\', \'http://myweb2.search.yahoo.com/myresults/bookmarklet?u=[URL]&t=[SUBJECT]\', \'images/blog/networks/yahoo.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'23\', \'Facebook\', \'http://facebook.com\', \'https://www.facebook.com/sharer/sharer.php?u=[URL]\', \'images/blog/networks/facebook.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'24\', \'Google +\', \'http://plus.google.com\', \'https://plus.google.com/share?url=[URL]\', \'images/blog/networks/google_plus.gif\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks` (`network_id`, `name`, `url`, `url_link`, `icon`) VALUES (\'25\', \'Twitter\', \'http://twitter.com\', \'http://twitter.com/intent/tweet?source=sharethiscom&text=[SUBJECT]&url=[URL]\', \'images/blog/networks/twitter.gif\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_networks_lang` (
  `network_id` int(8) unsigned NOT NULL default \'0\',
  `lang_id` int(2) unsigned NOT NULL default \'0\',
  PRIMARY KEY  (`network_id`,`lang_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'1\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'1\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'1\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'2\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'2\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'2\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'3\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'3\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'3\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'4\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'4\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'4\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'5\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'5\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'5\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'6\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'6\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'6\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'7\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'7\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'7\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'8\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'8\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'8\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'9\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'9\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'9\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'12\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'12\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'12\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'13\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'13\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'13\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'15\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'15\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'15\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'16\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'16\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'18\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'18\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'18\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'19\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'19\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'19\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'20\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'20\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'20\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'21\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'21\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'21\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'22\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'22\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'22\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'23\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'23\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'24\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'24\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'25\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_networks_lang` (`network_id`, `lang_id`) VALUES (\'25\', \'2\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_settings` (
  `name` varchar(50) NOT NULL,
  `value` varchar(250) NOT NULL,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_block_activated\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_block_messages\', \'5\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_comments_activated\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_comments_anonymous\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_comments_autoactivate\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_comments_editor\', \'textarea\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_comments_notification\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_comments_timeout\', \'30\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_general_introduction\', \'400\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_rss_activated\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_rss_comments\', \'20\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_rss_messages\', \'5\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_tags_hitlist\', \'5\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_blog_settings` (`name`, `value`) VALUES (\'blog_voting_activated\', \'1\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_blog_votes` (
  `vote_id` int(8) unsigned NOT NULL auto_increment,
  `message_id` int(6) unsigned NOT NULL default \'0\',
  `time_voted` int(14) unsigned NOT NULL default \'0\',
  `ip_address` varchar(15) NOT NULL default \'0.0.0.0\',
  `vote` enum(\'1\',\'2\',\'3\',\'4\',\'5\',\'6\',\'7\',\'8\',\'9\',\'10\') NOT NULL default \'1\',
  PRIMARY KEY  (`vote_id`),
  KEY `message_id` (`message_id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
	} catch (\Cx\Lib\UpdateException $e) {
                        return \Cx\Lib\UpdateUtil::DefaultActionHandler($e);
                        }
}