<?php
function _feedUpdate()
{
    global $objDatabase, $_ARRAYLANG;

    $query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` CHANGE `publicIdentifier` `publicIdentifier` VARCHAR( 255 ) NOT NULL DEFAULT ''";
    if (!$objDatabase->Execute($query)) {
        return _databaseError($query, $objDatabase->ErrorMsg());
    }

    $arrIndexes = $objDatabase->MetaIndexes(DBPREFIX.'module_feed_newsml_documents');
    if ($arrIndexes !== false) {
        if (!isset($arrIndexes['unique'])) {
            $query = "ALTER TABLE `".DBPREFIX."module_feed_newsml_documents` ADD UNIQUE `unique` (`publicIdentifier`)";
            if (!$objDatabase->Execute($query)) {
                return _databaseError($query, $objDatabase->ErrorMsg());
            }
        }
    } else {
        setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_feed_newsml_documents'));
        return false;
    }

    return true;
}
function _feedInstall() {
	global $_DBCONFIG;
	try {
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_feed_category` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(150) NOT NULL default \'\',
  `status` int(1) NOT NULL default \'1\',
  `time` int(100) NOT NULL default \'0\',
  `lang` int(1) NOT NULL default \'0\',
  `pos` int(3) NOT NULL default \'0\',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_feed_category` (`id`, `name`, `status`, `time`, `lang`, `pos`) VALUES (\'1\', \'Internet News\', \'1\', \'1134028532\', \'1\', \'0\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_feed_news` (
  `id` int(11) NOT NULL auto_increment,
  `subid` int(11) NOT NULL default \'0\',
  `name` varchar(150) NOT NULL default \'\',
  `link` varchar(150) NOT NULL default \'\',
  `filename` varchar(150) NOT NULL default \'\',
  `articles` int(2) NOT NULL default \'0\',
  `cache` int(4) NOT NULL default \'3600\',
  `time` int(100) NOT NULL default \'0\',
  `image` int(1) NOT NULL default \'1\',
  `status` int(1) NOT NULL default \'1\',
  `pos` int(3) NOT NULL default \'0\',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_feed_news` (`id`, `subid`, `name`, `link`, `filename`, `articles`, `cache`, `time`, `image`, `status`, `pos`) VALUES (\'3\', \'1\', \'pressetext.schweiz News\', \'http://www.pressetext.ch/produkte/rss/schlagzeilen.mc?land=ch&channel=ht&show=rss_2\', \'\', \'10\', \'3600\', \'1292836792\', \'1\', \'1\', \'3\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_feed_news` (`id`, `subid`, `name`, `link`, `filename`, `articles`, `cache`, `time`, `image`, `status`, `pos`) VALUES (\'4\', \'1\', \'pressetext.deutschland News\', \'http://pressetext.com/produkte/rss/schlagzeilen.mc?land=de&channel=ht&show=rss_2\', \'\', \'10\', \'3600\', \'1236268968\', \'1\', \'1\', \'4\')');
		\Cx\Lib\UpdateUtil::sql('INSERT INTO `'.DBPREFIX.'module_feed_news` (`id`, `subid`, `name`, `link`, `filename`, `articles`, `cache`, `time`, `image`, `status`, `pos`) VALUES (\'5\', \'1\', \'pressetext.österreich News\', \'http://pressetext.com/produkte/rss/schlagzeilen.mc?land=at&channel=ht&show=rss_2\', \'\', \'50\', \'3600\', \'1235730600\', \'1\', \'1\', \'5\')');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_feed_newsml_association` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `pId_master` text NOT NULL,
  `pId_slave` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_feed_newsml_categories` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `providerId` text NOT NULL,
  `name` varchar(40) NOT NULL default \'\',
  `subjectCodes` text NOT NULL,
  `showSubjectCodes` enum(\'all\',\'only\',\'exclude\') NOT NULL default \'all\',
  `template` text NOT NULL,
  `limit` smallint(6) NOT NULL default \'0\',
  `showPics` enum(\'0\',\'1\') NOT NULL default \'1\',
  `auto_update` tinyint(1) NOT NULL default \'0\',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_feed_newsml_documents` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `publicIdentifier` varchar(255) NOT NULL default \'\',
  `providerId` text NOT NULL,
  `dateId` int(8) unsigned NOT NULL default \'0\',
  `newsItemId` text NOT NULL,
  `revisionId` int(5) unsigned NOT NULL default \'0\',
  `thisRevisionDate` int(14) NOT NULL default \'0\',
  `urgency` smallint(5) unsigned NOT NULL default \'0\',
  `subjectCode` int(10) unsigned NOT NULL default \'0\',
  `headLine` varchar(67) NOT NULL default \'\',
  `dataContent` text NOT NULL,
  `is_associated` tinyint(1) unsigned NOT NULL default \'0\',
  `media_type` enum(\'Text\',\'Graphic\',\'Photo\',\'Audio\',\'Video\',\'ComplexData\') NOT NULL default \'Text\',
  `source` text NOT NULL,
  `properties` text NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `unique` (`publicIdentifier`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
		\Cx\Lib\UpdateUtil::sql('CREATE TABLE `'.DBPREFIX.'module_feed_newsml_providers` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `providerId` text NOT NULL,
  `name` varchar(40) NOT NULL default \'\',
  `path` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARACTER SET ' . $_DBCONFIG['charset'] . ' COLLATE ' . $_DBCONFIG['collation'] . ' COMMENT=\'cx3upgrade\'');
	} catch (\Cx\Lib\UpdateException $e) {
                        return \Cx\Lib\UpdateUtil::DefaultActionHandler($e);
                        }
}